# -*- coding: utf-8 -*-
from setuphelpers import *

uninstallkey = []

# Installation procedure: https://docs.microsoft.com/windows/wsl/install-win10
# Troobleshooting installation: https://docs.microsoft.com/windows/wsl/install-win10#troubleshooting-installation


def install():
    # Specific app values
    app_name = control.name

    # Installing the package
    if windows_version() >= '10.0.16299':
        with EnsureWUAUServRunning():
            try:
                print('Installing %s' % app_name)
                run_powershell('dism.exe /online /enable-feature /featurename:Microsoft-Windows-Subsystem-Linux /all /norestart')
            except:
                pass
    else:
        print("You need Windows 10 version 1709 minimum for installing WSL")

    print("A reboot is required to use %s" % app_name)


def uninstall():
    # Specific app values
    app_name = control.name

    # Uninstalling the package
    if windows_version() >= '10.0.16299':
        with EnsureWUAUServRunning():
            try:
                print('Uninstalling %s' % app_name)
                run_powershell('dism.exe /online /Disable-Feature /featurename:Microsoft-Windows-Subsystem-Linux /norestart')
            except:
                pass


def update_package():
    print('Download/Update package content from upstream binary sources')

    # Changing version of the package
    version = control.version.split('-')[0]
    pe = PackageEntry().load_control_from_wapt('.')
    pe.version = '%s-%s'%(version,int(pe.version.split('-',1)[1])+1)
    pe.save_control_to_wapt('.')
    print('Changing version to ' + pe.version + ' in WAPT\\control')



